function properties(theObject) {
    var n = (document.layers) ? 1:0;
    var ie = (document.all) ? 1:0;
    var i;
	var j='Object Properties:\n';
	if (typeof(theObject)=='object') {
		for (i in theObject) {
            if (typeof(theObject[i])=='object') j=j+i+' is an '+(n?'Object':'Object/Method')+'.\n';
            else if (typeof(theObject[i])=='function') j=j+i+' is a Method.\n';
			else j=j+'('+typeof(theObject[i])+') '+i+'='+theObject[i]+'\n';
		}
	}
    return j;
}

function hproperties(theObject) {
    var n = (document.layers) ? 1:0;
    var ie = (document.all) ? 1:0;
    var i;
	var j='Object Properties:<BR>';
	if (typeof(theObject)=='object') {
		for (i in theObject) {
            if (typeof(theObject[i])=='object') j=j+i+' is an '+(n?'Object':'Object/Method')+'.<BR>';
            else if (typeof(theObject[i])=='function') j=j+i+' is a Method.<BR>';
			else j=j+'('+typeof(theObject[i])+') '+i+'='+theObject[i]+'<BR>';
		}
	}
    return j;
}

function getCookie(Name) {
          var search = Name + "="
          if (document.cookie.length > 0) { // if there are any cookies
                    offset = document.cookie.indexOf(search) 
                    if (offset != -1) { // if cookie exists 
                              offset += search.length 
                              // set index of beginning of value
                              end = document.cookie.indexOf(";", offset) 
                              // set index of end of cookie value
                              if (end == -1) 
                                        end = document.cookie.length
                              return unescape(document.cookie.substring(offset, end))
                    } 
          }
}

function getCookieList() {
	var offset=0;
	var start=0;
	var tempObj=Object();
	if (document.cookie.length > 0) { // if there are any cookies
		while (offset<document.cookie.length) {
			start=offset;
			offset = document.cookie.indexOf("=",offset);
			if (offset != -1) { // if cookie exists 
				offset += search.length;
				// set index of beginning of value
				end = document.cookie.indexOf(";", offset);
				// set index of end of cookie value
				if (end == -1)
	            	end = document.cookie.length;
				tempObj[unescape(document.cookie.substring(start, offset))]=unescape(document.cookie.substring(offset+1,end));
			}
		}
	}
	return tempObj;
}

function validateFormElement(formElement,type,valDefault,allowNull,min,max) {
var parsed=0;
var i;
//alert('formElement: '+formElement+', type: '+type+', valDefault: '+valDefault+', allowNull: '+allowNull+', min: '+min+', max: '+max)
	if (typeof(valDefault)=="undefined" || valDefault=="undefined") {valDefault=""};
	if (formElement.type.toUpperCase()!="RADIO" && formElement.type.toUpperCase()!="CHECKBOX" && formElement.type.toUpperCase()!="SELECT-ONE" && formElement.type.toUpperCase()!="SELECT-MULTIPLE") {
		if (formElement.value.length==0) {
			if (typeof(allowNull)=="boolean" && !allowNull) { // Undefined or 0 means allow nulls.
				alert("Field does not allow null values.");
				return false;
			} else
			return true;
		}
	} else
	if (formElement.type.toUpperCase()=='RADIO') {
		var ok=0;
		if ( typeof(formElement.value) == "string" ) ok=true; else 
		for (i in formElement) {
			if(formElement[i].checked==true) {
				ok=true;
				break;
			}
		}
		if (!ok) {
			if ((typeof(allowNull)!="undefined"  && allowNull!="undefined") && (allowNull!=1)) { // Undefined or 0 means allow nulls.
				alert("Field does not allow null values.");
				return false;
			} else return true;
		}
	} else if (formElement.type.toUpperCase()=="SELECT-ONE" || formElement.type.toUpperCase()=="SELECT-MULTIPLE") {
		if(formElement.options[formElement.selectedIndex].value.length==0);
		else return 1;
	}
	if (type == "int") {
		parsed=parseInt(formElement.value);
		if (parsed != formElement.value) {
			alert("Please enter an integer value.");
			formElement.value=valDefault;  // Set to default value.
			return false;
		} else {
			if (typeof(max) != "undefined" && max!="undefined") if (parsed > max) { // Check minimum value
				alert("The number you have entered is too large.");
				formElement.value=valDefault;
				return false;
			} else
			if (typeof(min) != "undefined" && min!="undefined") if (parsed < min){ // Check minimum value
				alert("The number you have entered is too small.");
				formElement.value=valDefault;
				return false;
			}
		}
	} else
    if (type == "float") {
		parsed=parseFloat(formElement.value);
		if (parsed != formElement.value) {
			alert("Please enter a floating point value.");
formElement.value=valDefault;  // Set to default value.
			return false;
		} else {
			if ((typeof(max) != "undefined" && max!="undefined") && (parsed > max)) { // Check minimum value
				alert("The number you have entered is too large.");
				formElement.value=valDefault;
				return false;
			} else
			if ((typeof(min) != "undefined" && min!="undefined") && (parsed < min)) { // Check minimum value
				alert("The number you have entered is too small.");
				formElement.value=valDefault;
				return false;
			}
		}
	} else
    if (type == "str") {
		if (typeof(max) != "undefined" && max!="undefined" && (String(formElement.value).length > max)) { // Check minimum value
			alert("The string you have entered is too long.");
			formElement.value=valDefault;
			return false;
	} else
		if ((typeof(min) != "undefined" && min!="undefined") && (String(formElement.value).length < min)) { // Check minimum value
			alert("The string you have entered is too short.");
			formElement.value=valDefault;
			return false;
		}
	} else
    if (type == "bool") { // If min an max are defined, then use them as the valid boolean values.
		if ((typeof(min) != "undefined" && min!="undefined") && (typeof(max) != "undefined" && max!="undefined")) { 
			if ((formElement.value != min) && (formElement.value != max)) {
				alert("This is not a valid value.");
				formElement.value=valDefault;
				return false;
			}
		} else
		if ((formElement.value!="1") && (formElement.value!="0") && (String(formElement.value).toUpperCase()!="TRUE") && (String(formElement.value).toUpperCase()!="FALSE") && (String(formElement.value).toUpperCase()!="YES") && (String(formElement.value).toUpperCase()!="NO")) {
			alert("This is not a valid boolean value.");
			formElement.value=valDefault;
			return false;
		}
	}
	return true;
}

function copyArray(origional) {
	var copy=new Array(0);
	for (var i in origional) {
	    if (i=='length') continue;
		copy[i]=origional[i];
	}
	return copy;
}
