/*  wx_bounce version 2.0	    

    This file is part of the WidgetX library
    http://www.dynamic-core.net
*/
function wx_bounce(text,x,y,w,h) {
	this.id = "wx_bounce"+(wx_bounce.Count++)
	this.object = this.id + "Obj"
	eval(this.object + "=this")

	this.items=new Array()

	this.setFont('arial',true,false,2,14,18,'white')

	this.moveTo(x||0,y||0)
	this.setSize(w||200,h||64)
	this.setBgColor('#000000')

	this.setText(text||'widgetx-bounce')

	return this
}
wx_bounce.Count=0
wx_bounce.prototype = new DynLayer
wx_bounce.prototype.font=''
wx_bounce.prototype.fontend=''
wx_bounce.prototype.fh=18
wx_bounce.prototype.fw=14
wx_bounce.prototype.speed=50
wx_bounce.prototype.text=''
wx_bounce.prototype.getSubClass = function() {return wx_bounce}
wx_bounce.prototype.onCreate=function() { this.setVisible(false) }
wx_bounce.prototype.update = function() {
	var done=0
	var itm=null
	al=this.items.length
	for (var i=0;i<al; i++) {
		if (this.items[i].timer>0) this.items[i].timer--
		else {
			itm=this.items[i]
			yv=itm.yv
			itm.y+=yv
			if (yv<itm.maxv) itm.yv++
			if (itm.y>this.h-this.fh) {
				itm.y=this.h-this.fh
				itm.yv=-itm.yv
				if (itm.maxv>0) itm.maxv--
			}
			itm.dlyr.moveTo(null,this.items[i].y)
		}

		if (this.items[i].maxv==0) done++
	}

	if (done==al) {
		for (var i=0;i<al; i++) this.items[i].dlyr.moveTo(null,this.h-this.fh)
		this.onDone()
	} else setTimeout(this.object+'.update()',this.speed)
}
wx_bounce.prototype.setFont=function(face,bold,italic,size,width,height,color){
	this.font='<font face='+face+' size='+size+' color="'+color+'">'
	this.fontend='<font>'
	if (bold) {
		this.font+='<b>'
		this.fontend+='</b>'
	}
	if (italic) {
		this.font+='<i>'
		this.fontend+'</i>'
	}
	this.fw=width
	this.fh=height
}
wx_bounce.prototype.setText=function(text) {
	this.text=text
	for (var i=0;i<this.items.length; i++) this.items[i].dlyr.deleteFromParent()
	for (var i=0;i<this.text.length; i++) {
		this.items[i]=new Array()
		this.items[i].timer=i<<1
		this.items[i].y=-this.fh
		this.items[i].yv=0
		this.items[i].maxv=8

		this.items[i].dlyr=new DynLayer()

		this.items[i].dlyr.setHTML(this.font+this.text.substring(i,i+1)+this.fontend)
		this.items[i].dlyr.moveTo(i*this.fw,this.items[i].y)
		this.items[i].dlyr.setWidth(this.fw)
		this.items[i].dlyr.setHeight(this.fh)
		this.items[i].dlyr.setVisible(true)

		this.addChild(this.items[i].dlyr)
	}
}
wx_bounce.prototype.start=function() { setTimeout(this.object+'.update()',this.speed) }
wx_bounce.prototype.resize = function() { this.setWidth(this.text.length*this.fw) }
wx_bounce.prototype.remove = function() { this.deleteFromParent() }
wx_bounce.prototype.setPattern = function() {
	if (arguments.length==0) return
	var j=0
	for (var i=0; i<this.items.length; i++) {
		if (this.items[i]==null) this.items[i]=new Array()
		this.items[i].timer=arguments[j]
		j+=1
		if (j==arguments.length) j=0
	}
}

wx_bounce.prototype.onDone = new Function()
