/*  wx_flex version 2.0	    

    This file is part of the WidgetX library
    http://www.dynamic-core.net
*/

function wx_flex(w,h,contents){
	this.id = "wx_flex"+(wx_flex.Count++);
	this.object = this.id + "Obj";
	eval(this.object + "=this");

	this.contents=contents||''
	this.lines = new Array()
	this.pattern = new Array()
	
	this.setSize(w||100,h||50)

	return this
}
wx_flex.Count=0
wx_flex.prototype = new DynLayer
wx_flex.prototype.timerid=null
wx_flex.prototype.running=false
wx_flex.prototype.getSubClass = function() { return wx_flex }
wx_flex.prototype.setContents = function(contents) { this.contents=contents }
wx_flex.prototype.onCreate = function() {
		this.originalH=this.h
		this.setSize(this.w,this.h)
		this.setVisible(false)
	}
wx_flex.prototype.setLines = function (nr,size) { 
	for (var i=0; i<nr; i+=1) {
		this.lines[i]=new Array()
		this.lines[i].h=size
		this.lines[i].t=size
		this.lines[i].dlyr=new DynLayer()
		this.lines[i].dlyr.setVisible(true)
		this.lines[i].dlyr.setHTML(this.contents)
		this.lines[i].dlyr.setSize(this.w,size)
		this.lines[i].dlyr.moveTo(0,0)
		this.addChild(this.lines[i].dlyr)
	}
}
wx_flex.prototype.update = function() {
	var top=0
	var line=null
	var al=this.lines.length
	for (var i=0; i<al; i++) {
		line=this.lines[i]
		line.t=this.pattern[line.p++]
		line.dlyr.moveTo(null,top+line.t)
		top+=(line.t+line.h)
		if (line.p>=this.pattern.length) line.p=0
	}
	this.setHeight(this.originalH+top)
	if (is.ns) this.timerid = setTimeout(this.object+'.update()',25)
}

wx_flex.prototype.start = function () { 
	this.stop()

	if (is.ns) this.timerid = setTimeout(this.object+'.update()',25)
	else this.timerid = setInterval(this.object+'.update()',25) 
	this.running=true
}
wx_flex.prototype.stop = function () { 
	if(this.running)
		if (is.ns) clearTimeout(this.timerid)
		else clearInterval(this.timerid)
	this.running = false
}
wx_flex.prototype.wx_flexsetVisible=DynLayer.prototype.setVisible
wx_flex.prototype.setVisible = function (b) { 
	for (var i=0; i<60; i+=1) this.pattern[i]=((Math.sin(i/30*Math.PI+(Math.PI/2))+1)*2)

	var j=5
	al=this.lines.length
	for (var i=0; i<al; i+=1) {
		if (this.lines[i]==null) this.lines[i]=new Array()
		this.lines[i].h=this.pattern[j]
		j+=1
		if (j==this.pattern.length) j=0
		this.lines[i].p=j
	}

	for (var i=0;i<al; i+=1) this.lines[i].dlyr.setClip([i,this.w,(i+this.lines[i].t),0])
	
	this.wx_flexsetVisible(b)
}
wx_flex.prototype.remove = function() { this.deleteFromParent() }
