// Audio Object
// provides common controls for playing audio files
// 19990606

// Copyright (C) 1999 Ultrafluid (ultrafluid@xoommail.com) and Dan Steinman
// Distributed under the terms of the GNU Library General Public License
// Available at http://www.dansteinman.com/dynapi/

//var ns = (navigator.appName == 'Netscape') ? true : false;
//var ie = (navigator.appName == 'Microsoft Internet Explorer') ? true : false;

function Audio() {
	this.loop = false
	this.tracks = new Array();
	this.container=new DynLayer();
	this.container.setSize(200,900);
    this.myBorder=BorderFactory.getBorder('BasicBorder',1);
    this.myBorder.assignTo(this.container);
	DynAPI.document.addChild(this.container);
}
Audio.AudioGetMimeType=function (ext) {
	if (ext=='au' || ext=='AU') return "audio/basic"
	else if (ext=='wav' || ext=='WAV') return "audio/x-wav"
	else if (ext=='mid' || ext=='midi' || ext=='MID') return "audio/x-midi"
	else return ""
}
Audio.prototype.activate=function() {
	for (var i in this.tracks) {
		var obj = document[this.tracks[i].name]
		if (obj && (is.ns||is.ie)) this.tracks[i].obj = obj
	}
}
Audio.prototype.addTrack=function(tName,tSrc,mimeType) {
	var i = this.tracks.length
	var l=window.location;
	var path = l.href.substring(0,l.href.lastIndexOf("/"));
	tSrc=path+"/"+tSrc;
	alert(tSrc);
	this.tracks[i] = {
	    name : "JSAudio"+tName,
	    src : tSrc,
	    mime : Audio.AudioGetMimeType(tSrc.substring(tSrc.indexOf(".")+1))
	}
	this.tracks[i].html='<OBJECT ID="'+this.tracks[i].name+'" WIDTH=320 HEIGHT=240 '+
        'CLASSID="CLSID:22D6F312-B0F6-11D0-94AB-0080C74C7E95" '+
        'CODEBASE="http://activex.microsoft.com/activex/controls/mplayer/en/nsmp2inf.cab#Version=6,4,5,715" '+
        'STANDBY="Loading Microsoft Windows Media Player components..." '+
        'TYPE="application/x-oleobject">'+
        '<PARAM NAME="FileName" VALUE="'+tSrc+'"> '+
	'<PARAM NAME="AutoStart" VALUE="0"> '+
	'<PARAM NAME="ShowControls" VALUE="1"> '+
	'<PARAM NAME="ShowStatusBar" VALUE="0"> '+
	'<PARAM NAME="ShowDisplay" VALUE="0"> '+
	'<PARAM NAME="ClickToPlay" VALUE="0"> ';
    if (is.ns)
    this.tracks[i].html+='<EMBED TYPE="application/x-mplayer2" '+
        'PLUGINSPAGE="http://www.microsoft.com/isapi/redir.dll?prd=windows&sbp=mediaplayer&ar=Media&sba=Plugin&" '+
        'SRC="C:\Program Files\Windows Media Components\SDK\Samples\Plugin\demo.asf" '+
        'NAME="MediaPlayer" '+
        'WIDTH=320 '+
        'HEIGHT=240> '+
        '</EMBED>';
    this.tracks[i].html+='</OBJECT>';
	if (is.ns) {
	    this.tracks[i].html = '<embed name="'+this.tracks[i].name+'" src="'+tSrc+'" hidden="true" autostart="false" mastersound>\n'
	    this.container.elm.document.write(this.tracks[i].html);
	    this.tracks[i].obj=this.container.elm.document.embeds[this.tracks[i].name];
	} else 
	if (is.ie) {
/*
	    this.tracks[i].html = 
    	'<object id="' + this.tracks[i].name +
    	'" width=0 height=0 classid="CLSID:22D6F312-B0F6-11D0-94AB-0080C74C7E95" '+
    	'CODEBASE="http://activex.microsoft.com/activex/controls/mplayer/en/nsmp2inf.cab#Version=5,1,52,701" '+
    	'TYPE="application/x-oleobject">'+
    	'<param name="AutoStart" value="0">'+
//    	'<param name="AutoRewind" value="1">'+
    	'<param name="Filename" value="' + tSrc + '">'+
    	'<param name="PlayCount" value="1">'+
    	'</object>'
*/
    	this.container.elm.insertAdjacentHTML('beforeEnd',this.tracks[i].html);
    	this.tracks[i].obj=document.all[this.tracks[i].name];
    }
	
}
Audio.prototype.selectTrack=function(name) {
	for (var i in this.tracks) {
		if (this.tracks[i].name == "JSAudio"+name && this.tracks[i].obj) {
			this.selectedTrack = this.tracks[i]
			break
		}
	}
}
/*
Play  MediaPlayer.Play(); 
Pause MediaPlayer.Pause(); 
Stop  MediaPlayer.Stop(); 
Previous Track MediaPlayer.Previous(); 
Fast Reverse   MediaPlayer.FastReverse(); 
Fast Forward   MediaPlayer.FastForward(); 
Next Track     MediaPlayer.Next(); 
*/
Audio.prototype.play=function(name) {
	if (name) this.selectTrack(name)
	if (this.selectedTrack==null) {alert("select a track first");return;}
	if (is.ns) this.selectedTrack.obj.play()
	else if (is.ie) {
		if (this.loop) this.selectedTrack.obj.playCount = 0
		var props='';
		alert(this.selectedTrack.obj.id+".Play()");
		eval(this.selectedTrack.obj.id+".Play()");
	}
}

Audio.prototype.stop=function() {
	if (is.ns) this.selectedTrack.obj.stop()
	else {
		this.selectedTrack.obj.AutoRewind = 1
		this.selectedTrack.obj.next()
	}
}
Audio.prototype.pause=function()	{
	if (is.ns) this.selectedTrack.obj.pause()
	else {
		this.selectedTrack.obj.AutoRewind = 0
		this.selectedTrack.obj.stop()
	}
}
Audio.prototype.setVol=function(vol) {
	if (is.ns) this.selectedTrack.setvol(vol * 10);
	else if (is.ie) this.selectedTrack.volume = 3000 / -vol
}
Audio.prototype.startTime=function(start) {
	if (is.ns) this.selectedTrack.start_time(start);
	else if (is.ie) this.selectedTrack.selectionStart = start
}
Audio.prototype.endTime=function(end) {
	if (is.ns) this.selectedTrack.end_time(end);
	else if (is.ie) this.selectedTrack.selectionEnd = end
}
Audio.prototype.writeTracks=function() {
	if (is.ns && !navigator.javaEnabled()) return
	for (var i in this.tracks) {
		if (is.ie || (is.ns && navigator.mimeTypes[this.tracks[i].mime])) {
			document.write(this.tracks[i].html)
		}
	}
}