<?

/*

PHeadlines 0.12 (July 2, 2000)
an example script which uses the Pheadlines headline grabbing engine
http://www.dansteinman.com/pheadlines/

Copyright (C) 1999 Dan Steinman (dan@dansteinman.com)
This is free software under the terms of the GNU General Public License

*/

include('dplib.php3');
include('class.pheadlines.php3');

// -- DPLib: make a database connection ------------

$mysql = new MySQLDatabase;
$mysql->setDB('localhost','myuser','mypass');
$mysql->select_db('myportal');

// -- PEngines ------------

$headlines = new PHeadlines($mysql);

// $view is a query string (eg. pheadlines.php?view=slashdot)
// use the getLinks() method to retrieve a list of links

$links = $headlines->getLinks($view);

if ($links) {  // if links were found then print them
	print "<title>Pheadlines</title>";
	print "<h3>Pheadlines</h3>";
	
	$sitename = $headlines->sites[$view][0];  // full news site name
	$siteurl = $headlines->sites[$view][1];   // url to the site
	
	print "Headlines for <a href=\"$siteurl\">$sitename</a>";
	print "<ul>";
	
	while (list($title,$link) = each($links)) {  // for each news item get the title and the url
		print "<li><a href=\"$link\">$title</a>";  // print the link
	}
	
	print "</ul>";
}
else {  // if no $view site given then print a default page
	print "<title>Pheadlines</title>";
	print "<h3>Pheadlines</h3>";
	print "Available Headlines:<ul>";
	
	$links = $headlines->getList();   // get a list of available sites
	
	// set up links to view the headlines from those sites
	while (list($title,$link) = each($links)) {
		print "<li><a href=\"pheadlines.php3?view=$link\">$title</a>";
	}
	
	print "</ul>";
}

?>
